// $Id: base_math_finite.c,v 1.1 2003/07/24 04:55:43 troein Exp $
//
// BioArray Software Environment (BASE) - homepage http://base.thep.lu.se/
// Copyright (C) 2003 Carl Troein
//
// This file is part of BASE.
//
// BASE is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// BASE is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
#ifdef HAVE_CONFIG_H
	#include <config.h>
#endif

#include <math.h>
#ifdef HAVE_IEEEFP_H
#include <ieeefp.h>
#endif

#include <base_math.h>

int base_finite(double d)
{
#if defined(HAVE_FINITE)
	return finite(d);
#elif defined (HAVE_ISFINITE)
	return isfinite(d);
#elif defined (HAVE_ISINF) && defined (HAVE_ISNAN)
	return !isinf(d) && !isnan(d);
#else
	return d == 0. || (d == d) && (d + d != d);
#endif
}

int base_isinf(double d)
{
#if defined (HAVE_ISINF)
	return isinf(d);
#else
	return d != 0. && (d + d == d);
#endif
}

int base_isnan(double d)
{
#if defined (HAVE_ISNAN)
	return isnan(d);
#else
	return d != d;
#endif
}


